SystemOrganization addCategory: #'GMF-GraphicModel'!
SystemOrganization addCategory: #'GMF-GraphicModel-Tests'!

TestCase subclass: #GMFGAAssociationTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel-Tests'!

!GMFGAAssociationTests methodsFor: 'tests' stamp: 'RostislavNovak 12/19/2013 13:14'!
testInitialize! !

TestCase subclass: #GMFGAClassTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel-Tests'!

!GMFGAClassTests methodsFor: 'tests' stamp: 'RostislavNovak 12/17/2013 23:34'!
testInitialize
	| x |
	x := GMFGAClass new.
	self assert: (x linearLayout notNil).
	! !

TestCase subclass: #GMFGADrawableObjectTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel-Tests'!

!GMFGADrawableObjectTests methodsFor: 'tests' stamp: 'RostislavNovak 12/17/2013 22:53'!
testChangeColor
	| e |
	e := GMFGADrawableObject  new.
	self assert: e color == GMFGADrawableObject defaultColor.
	e color: Color white.
	self assert: e color == Color white.
	self deny: e color == GMFGADrawableObject defaultColor.! !

TestCase subclass: #GMFGAElementTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel-Tests'!

!GMFGAElementTests methodsFor: 'tests' stamp: 'RostislavNovak 12/15/2013 20:43'!
testChangeSize
	| e |
	e := GMFGAElement new.
	e width: 20.
	e height: 105.
	self assert: e width == 20.
	self assert: e height == 105.! !

!GMFGAElementTests methodsFor: 'tests' stamp: 'RostislavNovak 12/16/2013 22:08'!
testInitialize
	| e |
	e := GMFGAElement new.
	self assert: e color == GMFGAElement defaultColor.
	self assert: e leftTopPoint = (Point x: 20 y: 20).
	self assert: e width == 150.
	self assert: e height == 70.
	self assert: e middlePoint = (Point x: 95 y: 55).
	self assert: e isSelected = false.! !

!GMFGAElementTests methodsFor: 'tests' stamp: 'RostislavNovak 12/15/2013 21:38'!
testIsIn
	| e p c |
	e := GMFGAElement new.
	p := Point x: 40 y: 100.
	e move: p.
	c := Point x: 65 y: 125.
	self assert: (e isIn: c).
	c := Point x: 10 y: 10.
	self deny: (e isIn: c).
	! !

!GMFGAElementTests methodsFor: 'tests' stamp: 'RostislavNovak 12/15/2013 21:33'!
testMiddlePoint
	| e p m xm|
	e := GMFGAElement new.
	p := Point x: 40 y: 100.
	m := Point x: 115 y: 135.
	xm := e middlePoint.
	e leftTopPoint: p.
	self assert: e middlePoint = m.
	self deny: e middlePoint = xm.
	e width: 10.
	self deny: e middlePoint = m.
	m := Point x: 45 y: 135.
	self assert: e middlePoint = m.
	e height: 10.
	self deny: e middlePoint = m.
	m := Point x: 45 y: 105.
	self assert: e middlePoint = m.! !

!GMFGAElementTests methodsFor: 'tests' stamp: 'RostislavNovak 12/15/2013 21:31'!
testMove
	| e p xp|
	e := GMFGAElement new.
	p := Point x: 40 y: 100.
	xp := e leftTopPoint.
	e move: (Point x: 20 y: 80).
	self assert: e leftTopPoint = p.
	self deny: e leftTopPoint = xp.! !

!GMFGAElementTests methodsFor: 'tests' stamp: 'RostislavNovak 12/15/2013 21:28'!
testPoint
	| e p |
	p := Point x: 150 y: 150.
	e := GMFGAElement point: p.
	self assert: e color == GMFGAElement defaultColor.
	self assert: e leftTopPoint = p.
	self assert: e width == 150.
	self assert: e height == 70.
	self assert: e middlePoint = (Point x: 225 y: 185).! !

TestCase subclass: #GMFGALinearLayoutTests
	instanceVariableNames: 'layout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel-Tests'!

!GMFGALinearLayoutTests methodsFor: 'tests' stamp: 'RostislavNovak 12/17/2013 23:17'!
setUp
	layout := GMFGALinearLayout new.
	! !

!GMFGALinearLayoutTests methodsFor: 'tests' stamp: 'RostislavNovak 12/19/2013 18:15'!
testAddItem
	| x y |
	x := GMFGAItemText new.
	layout addItem: x.
	y := layout getItem: 1.
	self assert: x == y.
	layout addItem: GMFGAItemText new.
	y := layout getItem: 1.
	self assert: x == y.! !

!GMFGALinearLayoutTests methodsFor: 'tests' stamp: 'RostislavNovak 12/19/2013 18:15'!
testIsEmpty
	| x |
	self assert: layout isEmpty.
	x := GMFGAItemText new.
	layout addItem: x.
	self deny: layout isEmpty.
	layout removeItem: x.
	self assert: layout isEmpty.
	! !

!GMFGALinearLayoutTests methodsFor: 'tests' stamp: 'RostislavNovak 12/19/2013 18:18'!
testRemoveItem
	| x |
	layout addItem: GMFGAItemText new.
	layout addItem: (GMFGAItemText text: 'Hello').
	x := layout getItem: 1.
	layout removeItem: x.
	self deny: (x = (layout getItem: 1)).! !

Object subclass: #GMFGADrawableObject
	instanceVariableNames: 'color'
	classVariableNames: 'font scale transformationX transformationY widthOfLine'
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGADrawableObject commentStamp: '<historical>' prior: 0!
A GMFGADrawableObject is object which define must have methods and how to draw some objects.

Instance Variables
!

!GMFGADrawableObject class methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/16/2013 21:56'!
defaultColor
	^Color black.! !

!GMFGADrawableObject class methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 23:45'!
scale
	^ scale! !

!GMFGADrawableObject class methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 23:45'!
scale: anObject
	scale := anObject! !

!GMFGADrawableObject class methodsFor: 'accessing' stamp: 'RostislavNovak 12/19/2013 00:11'!
shift
	^Point x: transformationX y: transformationY.! !

!GMFGADrawableObject class methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 23:43'!
transformationX
	^ transformationX! !

!GMFGADrawableObject class methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 23:43'!
transformationX: anObject
	transformationX := anObject! !

!GMFGADrawableObject class methodsFor: 'accessing' stamp: 'RostislavNovak 12/19/2013 00:24'!
transformationX: x Y: y
	transformationX := transformationX + x.
	transformationY := transformationY + y.! !

!GMFGADrawableObject class methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 23:43'!
transformationY
	^ transformationY! !

!GMFGADrawableObject class methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 23:43'!
transformationY: anObject
	transformationY := anObject! !

!GMFGADrawableObject methodsFor: 'accessing' stamp: 'RostislavNovak 12/16/2013 21:55'!
color
	^ color! !

!GMFGADrawableObject methodsFor: 'accessing' stamp: 'RostislavNovak 12/16/2013 21:55'!
color: anObject
	color := anObject! !

!GMFGADrawableObject methodsFor: 'settings' stamp: 'RostislavNovak 12/16/2013 21:55'!
defaultColor
	color := GMFGAElement defaultColor.! !

!GMFGADrawableObject methodsFor: 'redering' stamp: 'RostislavNovak 12/19/2013 15:28'!
drawDashed: aCanvas
	| stroke |
	stroke := aCanvas setStrokePaint: color.
	stroke
		width: widthOfLine;
		dashes: (Array braceWith: 10 with: 3 / 4 * 10) offset: 0! !

!GMFGADrawableObject methodsFor: 'redering' stamp: 'RostislavNovak 12/19/2013 23:31'!
drawDiamond: aCanvas point: xPoint point: yPoint length: anInteger
	"drawing of triangle near X by way Y->X and size is defined by lenght on line"

	"rozmysli si 2x, zda se tim minis procitat a pote to jeste 3x zvaz"

	| path XYlen vectorXY middlePoint halfLenVector halfLenNormalVector |
	
	vectorXY := yPoint - xPoint.	" vektor bodu X a Y"
	XYlen := (vectorXY x * vectorXY x + (vectorXY y * vectorXY y)) sqrt.	"vzdalenost X a Y"
	halfLenVector := vectorXY / XYlen * anInteger / 2.	"vektor pulky vzdalenosti (ke stredu ctverce) = vydelime puvodni vektor jeho vzdalenosti a vynasobime novou velikosti"
	halfLenNormalVector := (halfLenVector y * -1) @ halfLenVector x.	"vektor o stejne velikosti, pouze kolmy"
	middlePoint := xPoint + halfLenVector.	"stredovy bod k nemuz pricitame vektory pro vykreslovani"
	aCanvas pathTransform
		restoreAfter: [ 
			self transformation: aCanvas.
			path := aCanvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: xPoint;
						lineTo: middlePoint + halfLenNormalVector;
						lineTo: middlePoint + halfLenVector;
						lineTo: middlePoint - halfLenNormalVector;
						close 
					].
			aCanvas setShape: path.
			aCanvas setPaint: Color white.
			aCanvas draw.
			(aCanvas setStrokePaint: Color black)
				width: 2;
				joinRound.
			aCanvas draw. ].
! !

!GMFGADrawableObject methodsFor: 'redering' stamp: 'RostislavNovak 12/19/2013 23:04'!
drawDiamondFill: aCanvas point: yPoint  point: xPoint length: anInteger
	"drawing of triangle near X by way Y->X and size is defined by lenght on line"

	"rozmysli si 2x, zda se tim minis procitat a pote to jeste 3x zvaz"

	| path XYlen vectorXY middlePoint halfLenVector halfLenNormalVector |
	vectorXY := yPoint - xPoint.	" vektor bodu X a Y"
	XYlen := (vectorXY x * vectorXY x + (vectorXY y * vectorXY y)) sqrt.	"vzdalenost X a Y"
	halfLenVector := vectorXY / XYlen * anInteger / 2.	"vektor pulky vzdalenosti (ke stredu ctverce) = vydelime puvodni vektor jeho vzdalenosti a vynasobime novou velikosti"
	halfLenNormalVector := (halfLenVector y * -1) @ halfLenVector x.	"vektor o stejne velikosti, pouze kolmy"
	middlePoint := xPoint + halfLenVector.	"stredovy bod k nemuz pricitame vektory pro vykreslovani"
	aCanvas pathTransform
		restoreAfter: [ 
			self transformation: aCanvas.
			path := aCanvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: xPoint;
						lineTo: middlePoint + halfLenNormalVector;
						lineTo: middlePoint + halfLenVector;
						lineTo: middlePoint - halfLenNormalVector;
						close 
					].
			aCanvas setShape: path.
			aCanvas setPaint: Color black.
			aCanvas draw.
			aCanvas setShape: path.
			(aCanvas setStrokePaint: Color black)
				width: 2;
				joinRound.
			aCanvas draw.].
! !

!GMFGADrawableObject methodsFor: 'redering' stamp: 'RostislavNovak 12/19/2013 16:05'!
drawLine: aCanvas Point: xPoint Point: yPoint
	| path |
	aCanvas pathTransform
		restoreAfter: [ 
			self transformation: aCanvas.
			path := aCanvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: xPoint;
						lineTo: yPoint ].
			aCanvas setShape: path.
			(aCanvas setStrokePaint: color) width: widthOfLine.
			aCanvas draw ]! !

!GMFGADrawableObject methodsFor: 'redering' stamp: 'RostislavNovak 12/16/2013 21:28'!
drawOn: aCanvas
	^self subclassResponsibility.! !

!GMFGADrawableObject methodsFor: 'redering' stamp: 'RostislavNovak 12/19/2013 16:05'!
drawRectangleCanvas: aCanvas point: xPoint corner: yPoint
	| path |
	aCanvas pathTransform
		restoreAfter: [ 
			self transformation: aCanvas.
			path := aCanvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: xPoint;
						lineToX: xPoint x Y: yPoint y;
						lineTo: yPoint;
						lineToX: yPoint x Y: xPoint y;
						close ].
			aCanvas setShape: path.
			aCanvas setStrokePaint: color.
			aCanvas draw ]! !

!GMFGADrawableObject methodsFor: 'redering' stamp: 'RostislavNovak 12/19/2013 23:19'!
drawText: aCanvas point: point text: text
	aCanvas pathTransform
		restoreAfter: [ 
			aCanvas pathTransform
				translateX: (point x * scale + transformationX) asInteger Y: ((point y + font getPreciseAscent) * scale + transformationY) asInteger;
				scaleBy: scale.
			aCanvas
				setFont: font;
				setPaint: color.
			aCanvas drawString: text ]! !

!GMFGADrawableObject methodsFor: 'redering' stamp: 'RostislavNovak 12/19/2013 23:22'!
drawTextWhite: aCanvas point: point text: text
	"self transformation: aCanvas."

	aCanvas pathTransform
		restoreAfter: [ 
			aCanvas pathTransform
				translateX: (point x * scale + transformationX) asInteger Y: ((point y + font getPreciseAscent) * scale + transformationY) asInteger;
				scaleBy: scale.
			aCanvas
				setFont: font;
				setPaint: Color white.
			aCanvas drawString: text ]	"aCanvas pathTransform loadIdentity."! !

!GMFGADrawableObject methodsFor: 'redering' stamp: 'RostislavNovak 12/19/2013 23:30'!
drawTriangle: aCanvas point: xPoint point: yPoint length: anInteger
	| path XYlen vectorXY vector1Size  zPoint normVector1Size vectorHalfSide |
	"drawing of triangle near X by way Y->X and size is defined by lenght on line"
	"rozmysli si 2x, zda se tim minis procitat a pote to jeste 3x zvaz"
	vectorXY := yPoint - xPoint.	" vektor bodu X a Y"
	XYlen := (vectorXY x * vectorXY x + (vectorXY y * vectorXY y)) sqrt.	"vzdalenost X a Y"
	vector1Size := vectorXY / XYlen.	"vektor prevedeny na takove souradnice, aby jeho velikost byla 1"
	zPoint := xPoint + (vector1Size * anInteger).	"bod lezici na primce XY, kde bude lezet zakladna trojuhelniku vytvorime prictenim vektoru nasobeneho delkou"
	normVector1Size := (vector1Size y * -1) @ vector1Size x.	"normala k puvodnimu vektoru - budem delat kolmici"
	vectorHalfSide := normVector1Size * ( anInteger / ( 3 sqrt ) ). "vyska RS trojuhelniku = strana * sqrt(3)/2 - z toho odvodime vztah pro pul strany = vyska / sqrt (3) "
	"uz jen pricteme k protnutemu bodu normalovy vektor nasobeny pulkou strany, oddechnem si a muzem kreslit"
			aCanvas pathTransform
		restoreAfter: [ 
			self transformation: aCanvas.
			path := aCanvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: xPoint;
						lineTo: zPoint + vectorHalfSide;
						lineTo: zPoint - vectorHalfSide;
						close ].
					
			aCanvas setShape: path.
			
			"aCanvas setPaint: fillColor.
			aCanvas draw."
			
			(aCanvas setStrokePaint: color) width: 2 ; joinRound.
			aCanvas draw ].! !

!GMFGADrawableObject methodsFor: 'initialize-release' stamp: 'RostislavNovak 1/5/2014 19:51'!
initialize
	color := GMFGADrawableObject defaultColor.
	font := LogicalFont familyName: 'Arial' pointSize: 18.
	transformationX isNil
		ifFalse: [ ^ self ].
	transformationX := 0.
	transformationY := 0.
	scale := 1.
	widthOfLine := 2! !

!GMFGADrawableObject methodsFor: 'redering' stamp: 'RostislavNovak 12/19/2013 15:46'!
transformation: aCanvas
	aCanvas pathTransform
		translateX: transformationX Y: transformationY;
		scaleBy: scale! !

GMFGADrawableObject subclass: #GMFGAElement
	instanceVariableNames: 'leftTopPoint height width selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGAElement commentStamp: '<historical>' prior: 0!
A GMFGAElement is main graphic element. It is border of all elements in diagram. Please use sub classes.

Instance Variables
	color:		<Color>
	height:		<Integer>
	leftTopPoint:		<Point>
	width:		<Integer>

color
	- color of element with wich will be drawed element

height
	- height of element

leftTopPoint
	- left top point of element

width
	- width of element
!

GMFGAElement subclass: #GMFGACover
	instanceVariableNames: 'metaModelClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGACover commentStamp: '<historical>' prior: 0!
A GMFGACover is only cover for metamodel class.

Instance Variables
	metamodelClass:		<metaModelClass>

metamodelClass
	- xxxxx
!

GMFGACover subclass: #GMFGAAssociation
	instanceVariableNames: 'leftGAElement rightGAElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGAAssociation class methodsFor: 'instance creation' stamp: 'RostislavNovak 12/19/2013 21:02'!
metaModelClass: mClass leftClass: xClass rightClass: yClass
	^ super new
		initialize;
		leftGAElement: xClass;
		rightGAElement: yClass;
		metaModelClass: mClass;
		leftTopPoint: xClass middlePoint;
		width: xClass middlePoint x - yClass middlePoint x;
		height: 1;
		yourself! !

!GMFGAAssociation methodsFor: 'accessing' stamp: 'RostislavNovak 12/19/2013 21:18'!
distance
	^ ((leftGAElement middlePoint x - rightGAElement middlePoint x)
		* (leftGAElement middlePoint x - rightGAElement middlePoint x)
		+
			((leftGAElement middlePoint y - rightGAElement middlePoint y)
				* (leftGAElement middlePoint y - rightGAElement middlePoint y))) sqrt! !

!GMFGAAssociation methodsFor: 'rendering' stamp: 'RostislavNovak 12/19/2013 23:19'!
drawOn: aCanvas
	| leftPoint rightPoint mid |
	mid := self middlePoint.
	leftPoint := leftGAElement pointNearestTo: mid.
	rightPoint := rightGAElement pointNearestTo: mid.
	self drawQuantity: aCanvas left: leftPoint right: rightPoint.
	self drawText: aCanvas point: mid text: metaModelClass name asString.
	self drawLine: aCanvas Point: leftPoint Point: rightPoint.
	! !

!GMFGAAssociation methodsFor: 'accessing' stamp: 'RostislavNovak 12/19/2013 22:24'!
drawQuantity: aCanvas left: leftPoint right: rightPoint
	| q |
	q := leftPoint quadrantOf: rightPoint.
	q == 1
		ifTrue: [ 
			self
				drawText: aCanvas
				point: (Point x: leftPoint x + 40 y: leftPoint y + 20)
				text: metaModelClass startQuantity asString.
			self
				drawText: aCanvas
				point: (Point x: rightPoint x - 40 y: rightPoint y - 40)
				text: metaModelClass endQuantity asString ].
	q == 2
		ifTrue: [ 
			self
				drawText: aCanvas
				point: (Point x: leftPoint x - 40 y: leftPoint y + 20)
				text: metaModelClass startQuantity asString.
			self
				drawText: aCanvas
				point: (Point x: rightPoint x + 40 y: rightPoint y - 40)
				text: metaModelClass endQuantity asString ].
	q == 3
		ifTrue: [ 
			self
				drawText: aCanvas
				point: (Point x: leftPoint x - 40 y: leftPoint y + 20)
				text: metaModelClass startQuantity asString.
			self
				drawText: aCanvas
				point: (Point x: rightPoint x + 40 y: rightPoint y - 40)
				text: metaModelClass endQuantity asString ].
	q == 4
		ifTrue: [ 
			self
				drawText: aCanvas
				point: (Point x: leftPoint x + 10 y: leftPoint y - 40)
				text: metaModelClass startQuantity asString.
			self drawText: aCanvas point: (Point x: rightPoint x - 40 y: rightPoint y) text: metaModelClass endQuantity asString ]! !

!GMFGAAssociation methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 23:38'!
leftGAElement
	^ leftGAElement! !

!GMFGAAssociation methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 23:38'!
leftGAElement: anObject
	leftGAElement := anObject! !

!GMFGAAssociation methodsFor: 'accessing' stamp: 'RostislavNovak 12/19/2013 21:23'!
middlePoint
	^Point x: ((leftGAElement middlePoint x + rightGAElement middlePoint x)/2) y: ((leftGAElement middlePoint y + rightGAElement middlePoint y)/2) .! !

!GMFGAAssociation methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 23:38'!
rightGAElement
	^ rightGAElement! !

!GMFGAAssociation methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 23:38'!
rightGAElement: anObject
	rightGAElement := anObject! !

GMFGAAssociation subclass: #GMFGACharacterization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGACharacterization methodsFor: 'rendering' stamp: 'RostislavNovak 12/19/2013 22:25'!
drawOn: aCanvas
	| leftPoint rightPoint mid |
	mid := self middlePoint.
	leftPoint := leftGAElement pointNearestTo: mid.
	rightPoint := rightGAElement pointNearestTo: mid.
	self drawLine: aCanvas Point: leftPoint Point: rightPoint.
	self drawQuantity: aCanvas left: leftPoint right: rightPoint.
	self drawText: aCanvas point: mid text: '<<characterization>>
	', metaModelClass name asString.! !

GMFGAAssociation subclass: #GMFGAComponentOf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGAComponentOf methodsFor: 'rendering' stamp: 'RostislavNovak 12/19/2013 23:05'!
drawOn: aCanvas
	| leftPoint rightPoint mid|
	mid := self middlePoint.
	leftPoint := leftGAElement pointNearestTo: mid.
	rightPoint := rightGAElement pointNearestTo: mid.
	self drawLine: aCanvas Point: leftPoint Point: rightPoint.
	self drawQuantity: aCanvas left:  leftPoint right: rightPoint.
	self drawDiamond: aCanvas point: rightPoint point: leftPoint length: 20.
	self drawText: aCanvas point: rightPoint-16 text: 'c'.! !

GMFGAAssociation subclass: #GMFGADerivation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGADerivation methodsFor: 'rendering' stamp: 'RostislavNovak 12/19/2013 22:26'!
drawOn: aCanvas
	| leftPoint rightPoint mid |
	mid := self middlePoint.
	leftPoint := leftGAElement pointNearestTo: mid.
	rightPoint := rightGAElement pointNearestTo: mid.
	self drawLine: aCanvas Point: leftPoint Point: rightPoint.
	self drawQuantity: aCanvas left: leftPoint right: rightPoint.
	self drawText: aCanvas point: mid text: '<<derivation>>
	', metaModelClass name asString.! !

GMFGAAssociation subclass: #GMFGAFormalAssociation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGAFormalAssociation methodsFor: 'rendering' stamp: 'RostislavNovak 12/19/2013 22:26'!
drawOn: aCanvas
	| leftPoint rightPoint mid|
	mid := self middlePoint.
	leftPoint := leftGAElement pointNearestTo: mid.
	rightPoint := rightGAElement pointNearestTo: mid.
	self drawLine: aCanvas Point: leftPoint Point: rightPoint.
	self drawQuantity: aCanvas left: leftPoint right: rightPoint.
	self drawText: aCanvas point: mid text: '<<formal>>
	/', metaModelClass name asString.! !

GMFGAAssociation subclass: #GMFGAInheritance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGAInheritance methodsFor: 'rendering' stamp: 'RostislavNovak 12/19/2013 22:58'!
drawOn: aCanvas
	| leftPoint rightPoint mid |
	mid := self middlePoint.
	leftPoint := leftGAElement pointNearestTo: mid.
	rightPoint := rightGAElement pointNearestTo: mid.
	self drawLine: aCanvas Point: leftPoint Point: rightPoint.
	self drawTriangle: aCanvas point:  rightPoint point: leftPoint length: 10.! !

GMFGAAssociation subclass: #GMFGAMediation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGAMediation methodsFor: 'rendering' stamp: 'RostislavNovak 12/19/2013 22:26'!
drawOn: aCanvas
	| leftPoint rightPoint mid |
	mid := self middlePoint.
	leftPoint := leftGAElement pointNearestTo: mid.
	rightPoint := rightGAElement pointNearestTo: mid.
	self drawLine: aCanvas Point: leftPoint Point: rightPoint.
	self drawQuantity: aCanvas left: leftPoint right: rightPoint.
	self drawText: aCanvas point: mid text: '<<mediation>>
	', metaModelClass name asString.! !

GMFGAAssociation subclass: #GMFGAMemberOf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGAMemberOf methodsFor: 'rendering' stamp: 'RostislavNovak 12/19/2013 23:01'!
drawOn: aCanvas
	| leftPoint rightPoint mid |
	mid := self middlePoint.
	leftPoint := leftGAElement pointNearestTo: mid.
	rightPoint := rightGAElement pointNearestTo: mid.
	self drawLine: aCanvas Point: leftPoint Point: rightPoint.
	self drawQuantity: aCanvas left: leftPoint right: rightPoint.
	self drawDiamond: aCanvas point: leftPoint point: rightPoint length: 20.
	self drawText: aCanvas point: rightPoint-20 text: 'M'.! !

GMFGAAssociation subclass: #GMFGASubCollectionOf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGASubCollectionOf methodsFor: 'rendering' stamp: 'RostislavNovak 12/19/2013 23:04'!
drawOn: aCanvas
	| leftPoint rightPoint mid |
	mid := self middlePoint.
	leftPoint := leftGAElement pointNearestTo: mid.
	rightPoint := rightGAElement pointNearestTo: mid.
	self drawLine: aCanvas Point: leftPoint Point: rightPoint.
	self drawQuantity: aCanvas left: leftPoint right: rightPoint.
	self drawDiamondFill: aCanvas point: leftPoint point: rightPoint length: 20.
	self drawTextWhite: aCanvas point: rightPoint-16 text: 'c'.! !

GMFGAAssociation subclass: #GMFGASubQuantityOf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGASubQuantityOf methodsFor: 'rendering' stamp: 'RostislavNovak 12/19/2013 23:04'!
drawOn: aCanvas
	| leftPoint rightPoint mid |
	mid := self middlePoint.
	leftPoint := leftGAElement pointNearestTo: mid.
	rightPoint := rightGAElement pointNearestTo: mid.
	self drawLine: aCanvas Point: leftPoint Point: rightPoint.
	self drawQuantity: aCanvas left: leftPoint right: rightPoint.
	self drawDiamondFill: aCanvas point: leftPoint point: rightPoint length: 20.
	self drawTextWhite: aCanvas point: rightPoint-16 text: 'q'.! !

GMFGACover subclass: #GMFGAClass
	instanceVariableNames: 'linearLayout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGAClass commentStamp: '<historical>' prior: 0!
A GMFGAClass is graphic representation of class.

Instance Variables
	metamodelClass:		<Object>

metamodelClass
	- xxxxx
!

!GMFGAClass class methodsFor: 'instance creation' stamp: 'RostislavNovak 12/18/2013 01:32'!
metaModelClass: xClass
	^ super new
		initialize;
		metaModelClass: xClass;
		yourself! !

!GMFGAClass class methodsFor: 'instance creation' stamp: 'RostislavNovak 12/17/2013 22:40'!
new
	^ super new
		initialize;
		yourself! !

!GMFGAClass methodsFor: 'rendering' stamp: 'RostislavNovak 12/19/2013 16:01'!
drawOn: aCanvas
	self reset.
	linearLayout width = width
		ifFalse: [ width := linearLayout width ].
	linearLayout height = height
		ifFalse: [ height := linearLayout height ].
	self
		drawRectangleCanvas: aCanvas
		point: leftTopPoint
		corner: (Point x: leftTopPoint x + width y: leftTopPoint y + height).
	linearLayout drawOn: aCanvas.
	selected
		ifTrue: [ super drawOn: aCanvas ]! !

!GMFGAClass methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/17/2013 23:17'!
initialize
	super initialize.
	linearLayout := GMFGALinearLayout point: (leftTopPoint + 5).! !

!GMFGAClass methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 22:51'!
linearLayout
	^ linearLayout.! !

!GMFGAClass methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 22:37'!
linearLayout: anObject
	linearLayout := anObject! !

!GMFGAClass methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/18/2013 01:31'!
reset
	linearLayout := GMFGALinearLayout point: (leftTopPoint + 5).
	linearLayout addItem: (GMFGAItemText text: metaModelClass name asString).
	linearLayout addItem: (GMFGAItemText text: '<<' , metaModelClass class name asString , '>>' ).
	linearLayout addItem: GMFGAItemLine new.
	metaModelClass attributes do:[ :v | linearLayout addItem: (GMFGAItemText text: v asString)].
	linearLayout addItem: GMFGAItemLine new.
	metaModelClass methods do:[ :v | linearLayout addItem: (GMFGAItemText text: v asString)].! !

!GMFGACover methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 01:31'!
metaModelClass
	^ metaModelClass! !

!GMFGACover methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 01:31'!
metaModelClass: anObject
	metaModelClass := anObject! !

!GMFGAElement class methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/15/2013 21:02'!
point: aPoint
	^ super new
		initialize;
		leftTopPoint: aPoint;
		yourself! !

!GMFGAElement methodsFor: 'rendering' stamp: 'RostislavNovak 12/19/2013 16:01'!
drawOn: aCanvas
	self drawRectangleCanvas: aCanvas point: leftTopPoint-4  corner: (Point x: leftTopPoint x + width y: leftTopPoint y + height)+4.
	self drawDashed: aCanvas.! !

!GMFGAElement methodsFor: 'accessing' stamp: 'RostislavNovak 12/15/2013 20:46'!
height
	^ height! !

!GMFGAElement methodsFor: 'accessing' stamp: 'RostislavNovak 12/15/2013 20:46'!
height: anObject
	height := anObject! !

!GMFGAElement methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/18/2013 00:47'!
initialize
	super initialize.
	color := GMFGAElement defaultColor.
	leftTopPoint  := Point x: 20 y: 20.
	width := 150.
	height := 70.
	selected := false.! !

!GMFGAElement methodsFor: 'testing' stamp: 'RostislavNovak 12/15/2013 21:36'!
isIn: aPoint 
	| rec |
	rec := Rectangle origin: leftTopPoint corner: (Point x: (leftTopPoint x + width) y: (leftTopPoint y + height)).
	^rec containsPoint: aPoint.
	! !

!GMFGAElement methodsFor: 'accessing' stamp: 'RostislavNovak 12/16/2013 22:07'!
isSelected
	^ selected! !

!GMFGAElement methodsFor: 'accessing' stamp: 'RostislavNovak 12/15/2013 20:46'!
leftTopPoint
	^ leftTopPoint! !

!GMFGAElement methodsFor: 'accessing' stamp: 'RostislavNovak 12/15/2013 20:46'!
leftTopPoint: anObject
	leftTopPoint := anObject! !

!GMFGAElement methodsFor: 'accessing' stamp: 'RostislavNovak 12/15/2013 21:27'!
middlePoint
	^(Point x: leftTopPoint x + (width/2) y: leftTopPoint y + (height/2)).! !

!GMFGAElement methodsFor: 'settings' stamp: 'RostislavNovak 12/15/2013 20:56'!
move: aPoint
	leftTopPoint := leftTopPoint + aPoint.! !

!GMFGAElement methodsFor: 'testing' stamp: 'RostislavNovak 12/19/2013 20:54'!
pointNearestTo: aPoint 
	| rec |
	rec := Rectangle origin: leftTopPoint corner: (Point x: (leftTopPoint x + width) y: (leftTopPoint y + height)).
	^rec pointNearestTo: aPoint ! !

!GMFGAElement methodsFor: 'accessing' stamp: 'RostislavNovak 12/16/2013 22:06'!
selected: anObject
	selected := anObject! !

!GMFGAElement methodsFor: 'accessing' stamp: 'RostislavNovak 12/15/2013 20:46'!
width
	^ width! !

!GMFGAElement methodsFor: 'accessing' stamp: 'RostislavNovak 12/15/2013 20:46'!
width: anObject
	width := anObject! !

GMFGAElement subclass: #GMFGALinearLayout
	instanceVariableNames: 'items skip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGALinearLayout commentStamp: '<historical>' prior: 0!
A GMFGALinearLayout is layout for class items like text.

Instance Variables
	items:		<OrderedCollection >

items
	- collection of items.
!

!GMFGALinearLayout methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 00:49'!
addItem: xObject
	items addLast: xObject.
	xObject isLine
		ifFalse: [ 
			xObject size > width
				ifTrue: [ width := xObject size + 10 ] ].
	height := height + 30.! !

!GMFGALinearLayout methodsFor: 'rendering' stamp: 'RostislavNovak 12/19/2013 15:39'!
drawOn: aCanvas
	| point |
	point := leftTopPoint.
	items
		do: [ :i | 
			i isLine
				ifTrue: [ i drawOn: aCanvas point: point width: width ]
				ifFalse: [ 
					i drawOn: aCanvas point: point.
					point := Point x: point x y: point y + skip ] ].
! !

!GMFGALinearLayout methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 22:17'!
getItem: xAt
	^items at: xAt.! !

!GMFGALinearLayout methodsFor: 'initialize-release' stamp: 'RostislavNovak 12/18/2013 00:53'!
initialize
	super initialize.
	items := OrderedCollection new.
	skip := 30.
	height := -30.! !

!GMFGALinearLayout methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 22:20'!
isEmpty
	^items isEmpty.! !

!GMFGALinearLayout methodsFor: 'accessing' stamp: 'RostislavNovak 12/16/2013 23:16'!
items
	^items copy.! !

!GMFGALinearLayout methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 00:52'!
removeItem: xObject
	items remove: xObject.
	height := height - 30.! !

!GMFGALinearLayout methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 00:48'!
size
	^items size.! !

GMFGADrawableObject subclass: #GMFGAItemLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGAItemLine commentStamp: '<historical>' prior: 0!
A GMFGAItemLine is item for linear layout.

Instance Variables
!

!GMFGAItemLine methodsFor: 'redering' stamp: 'RostislavNovak 12/19/2013 15:57'!
drawOn: aCanvas point: point width: width
	self drawLine: aCanvas Point: point - (4@0) Point: (Point x: point x - 7  + width y: point y).! !

!GMFGAItemLine methodsFor: 'redering' stamp: 'RostislavNovak 12/17/2013 23:18'!
isLine
	^true! !

GMFGADrawableObject subclass: #GMFGAItemText
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!GMFGAItemText commentStamp: '<historical>' prior: 0!
A GMFGAItemText is text in linear layout.

Instance Variables
	text:		<String>

text
	- which will be drawed or holded in class.
!

!GMFGAItemText class methodsFor: 'instance creation' stamp: 'RostislavNovak 12/18/2013 00:38'!
text: string
	^ super new
		initialize;
		text: string;
		yourself! !

!GMFGAItemText methodsFor: 'redering' stamp: 'RostislavNovak 12/19/2013 15:50'!
drawOn: aCanvas point: point
	self drawText: aCanvas point: point text: text.
! !

!GMFGAItemText methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 23:18'!
isLine
	^false! !

!GMFGAItemText methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 00:35'!
size
	^font widthOfString: text.! !

!GMFGAItemText methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 22:45'!
text
	^ text! !

!GMFGAItemText methodsFor: 'accessing' stamp: 'RostislavNovak 12/17/2013 22:45'!
text: anObject
	text := anObject! !
